<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html" indent="yes"/>
    <xsl:template match="/TESTSLOG">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head><title>Tests log</title></head>
            <body>
                <h1>FAILED tests</h1>
                <table width="100%" border="2">
                    <tr>
                        <td>class</td>
                        <td>function</td>
                        <td>output</td>
                    </tr>
                    <xsl:apply-templates select="//TEST[@result='FAILED']"/>
                </table>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="TEST">
    <tr>
        <td><xsl:value-of select="@class"/></td>
        <td><xsl:value-of select="@function"/></td>
        <td><xsl:value-of select="."/></td>
    </tr>
    </xsl:template>


</xsl:stylesheet>