// Author : Sidnev Alexey
// Tester :
// Creation date : 20.01.2006
// Modification date: 01.02.2006, 16.07.2006 (S. Lyalin)
// Testing date: 
// Description : Header of random number generation class.

#ifndef RandH
#define RandH

#include "../ts_stdafx.hpp"

#define ARAGELI_TESTSYS_RAND_COUNT 100
#define ARAGELI_TESTSYS_RAND_A 8193//5
#define ARAGELI_TESTSYS_RAND_C 4097//49
#define ARAGELI_TESTSYS_RAND_M (1<<16)//(1<<8)

class RNG//RNG - random number generation
{
private:
	int mas[55];
	int param, range, prev;
	int bottom;

	int ShortRand();

	void init (int tParam, int tRange);

public:
	RNG(int tParam) { init(tParam, 1<<16); }
	
	//tRange    (   )
	RNG(int tParam, int tRange) { init(tParam, tRange); }
	
	~RNG();

	int Rand();
};

#endif
